package com.trace.ar.drawing.adapter;

import android.app.Activity;
import android.content.Intent;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.FrameLayout;
import android.widget.ImageView;

import androidx.annotation.NonNull;
import androidx.cardview.widget.CardView;
import androidx.recyclerview.widget.RecyclerView;

import com.trace.ar.drawing.ARApp;
import com.trace.ar.drawing.R;
import com.trace.ar.drawing.activity.DetailActivity;
import com.trace.ar.drawing.helper.ImportUri;
import com.trace.ar.drawing.helper.ObjectBox;
import com.trace.ar.drawing.listener.OnDeleteLikeListener;

import java.util.ArrayList;
import java.util.List;

public class ImportAdapter extends RecyclerView.Adapter<ImportAdapter.HomeVH> {


    private Activity mCon;
    private List<ImportUri> data = new ArrayList<>();
    private OnDeleteLikeListener listener;

    public void setListener(OnDeleteLikeListener listener) {
        this.listener = listener;
    }

    public void setData(List<ImportUri> data) {
        this.data = data;
        notifyDataSetChanged();
    }
    public ImportAdapter(Activity mCon) {
        this.mCon = mCon;
    }

    public void addData(ImportUri newData){
//        if(data.size() == 0){
//            Log.d(ARApp.TAG, "---------notifyDataSetChanged--");
//
//            notifyDataSetChanged();
//            return;
//        }
        data.add(newData);
        int i = data.size() - 1;
        Log.d(ARApp.TAG, "---------addData  i="+i);
        notifyItemInserted(i);
        notifyItemChanged(i);

    }

    @NonNull
    @Override
    public HomeVH onCreateViewHolder(@NonNull ViewGroup parent, int viewType) {
        View view = LayoutInflater.from(parent.getContext()).inflate(R.layout.adapter_thumb, parent, false);
        return new HomeVH(view);
    }

    @Override
    public void onBindViewHolder(@NonNull HomeVH holder, int position) {
        ImportUri importUri = data.get(position);
        String path = importUri.getUri();
        Log.d(ARApp.TAG, "---------ImportAdapter  position="+position+"------" + path);
         new Thread(new Runnable() {
             @Override
             public void run() {
                 Bitmap bitmap = BitmapFactory.decodeFile(path);
                 mCon.runOnUiThread(()->{
                     holder.previewIm.setImageBitmap(bitmap);
                 });

             }
         }).start();


        boolean b = ObjectBox.queryIsLike(path);
        holder.imFavorite.setSelected(b);
        holder.cardView.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                Intent intent = new Intent(mCon, DetailActivity.class);
                intent.putExtra(ARApp.Key_Camera, path);
                mCon.startActivity(intent);
            }
        });

        holder.cardFavorite.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                boolean selected = holder.imFavorite.isSelected();
                holder.imFavorite.setSelected(!selected);
                boolean newSelect = holder.imFavorite.isSelected();
                if(newSelect){
                    ObjectBox.insertOrUpdateLike(path);
                }else {
                    ObjectBox.deleteLike(path);

                }
            }
        });


    }

    @Override
    public int getItemCount() {
        return data.size();
    }

    public static class HomeVH extends RecyclerView.ViewHolder {
        private ImageView previewIm, imFavorite;

        private CardView cardView;
        private FrameLayout cardFavorite;

        public HomeVH(@NonNull View itemView) {
            super(itemView);
            previewIm = itemView.findViewById(R.id.imPreview);
            cardView = itemView.findViewById(R.id.card_view);
            cardFavorite = itemView.findViewById(R.id.card_favorite);
            imFavorite = itemView.findViewById(R.id.im_favorite);
        }


    }
}
